/*

	generic proto-typedefs for use with experimental strong
	       typing macro system  GCOOPE version 3.1.

			by Brian Lee Price

		Released as Public Domain  July, 1994.

*/

/* typedef prototypes for New methods */

PROTO(object, NewClass, (object, int, int,...));
PROTO(object, NewArray, (object, word, word));
PROTO(object, NewChar, (object, char));
PROTO(object, NewCollection, (object, word));
PROTO(object, NewDynmem, (object, word));
PROTO(object, NewFile, (object, const char *, const char *));
PROTO(object, NewLongInt, (object, long));
PROTO(object, NewLowStream, (object));
PROTO(object, NewPointer, (object, void *));
PROTO(object, NewShortInt, (object, short));
PROTO(object, NewStdStream, (object, FILE *));
PROTO(object, NewStream, (object, object, const char *));
PROTO(object, NewString, (object, char *));
PROTO(object, NewUnsigned, (object, word));

/* changeVal and valueOf have different types for nearly every object */

PROTO(object, changeVal, (object,...));  /* this doesn't do much good */
/* valueOf is impossible, use the return value type casts in gcoope10.h */

/*  typedef prototypes for standard methods 	*/

PROTO(object, reSize, (object, word));
PROTO(object, putElem, (object, word, void *));
PROTO(void *, getElem, (object, word));
PROTO(word, sizeOf, (object));
PROTO(word, lengthOf, (object));
PROTO(word, numElems, (object));
PROTO(object, classOf, (object));
PROTO(object, ivSize, (object));
PROTO(object, respondsTo, (object, generic));
PROTO(object, deepCopy, (object));
PROTO(object, shallowCopy, (object, object));
PROTO(object, asString, (object));
PROTO(object, asHexStr, (object));
PROTO(object, asShortInt, (object));
PROTO(object, asLongInt, (object));
PROTO(object, asUnsigned, (object));
PROTO(object, asChar, (object));
PROTO(int, addUnit, (object, void *));
PROTO(object, rmvUnit, (object, int));
PROTO(void *, getUnit, (object, int));
PROTO(object, compact, (object, boolean));
PROTO(long, getPos, (object));
PROTO(object, strmErr, (object));
PROTO(object, setPos, (object, long, int));
PROTO(object, putByte, (object, byte));
PROTO(int, getByte, (object));
PROTO(object, clrErr, (object));
PROTO(object, SetBuf, (object, char *, int, word));
PROTO(object, Flush, (object));
PROTO(object, Stat, (object));
PROTO(int, Putc, (object, char));
PROTO(int, Getc, (object));
PROTO(int, UnGet, (object, char));
PROTO(object, Puts, (object, object));
PROTO(object, Gets, (object, int));
PROTO(int, Write, (object, const char *, word, word));
PROTO(int, Read, (object, char *, word, word));
PROTO(void *, addressOf, (object));
